com.holonplatform.datastore.mongo.core.expression

## Interface BsonQuery

- All Superinterfaces:
    com.holonplatform.core.Expression

      public interface BsonQuery
      extends com.holonplatform.core.Expression

  MongoDB query expression.
  Since:
    5.2.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `BsonQuery.Builder` `BsonQuery` builder.

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `com.holonplatform.core.Expression.ExpressionResolverFunction<E extends com.holonplatform.core.Expression,R extends com.holonplatform.core.Expression>, com.holonplatform.core.Expression.InvalidExpressionException`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static BsonQuery.Builder` | `builder(BsonQueryDefinition definition)` Get a new `BsonQuery` builder.
    `BsonQueryDefinition` | `getDefinition()` Get the query definition.
    `Optional<String>` | `getDistinctFieldName()` If the query is a distinct field value query, get the field name.
    `Optional<BsonProjection<?>>` | `getProjection()` Get the query projection.

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

- - ### Method Detail

    - #### getDefinition

          BsonQueryDefinition getDefinition()

      Get the query definition.
      Returns:
        The query definition

    - #### getProjection

          Optional<BsonProjection<?>> getProjection()

      Get the query projection.
      Returns:
        Optional query projection

    - #### getDistinctFieldName

          Optional<String> getDistinctFieldName()

      If the query is a distinct field value query, get the field name.
      Returns:
        Distinct field name, or empty if not a distinct field value query

    - #### builder

          static BsonQuery.Builder builder(BsonQueryDefinition definition)

      Get a new `BsonQuery` builder.
      Parameters:
        `definition` - Query definition
      Returns:
        A new `BsonQuery` builder

Copyright © 2019 The Holon Platform. All rights reserved.